// SPDX-FileCopyrightText: Copyright 2024 shadPS4 Emulator Project
// SPDX-License-Identifier: GPL-2.0-or-later

#pragma once

// Generic
#define ORBIS_OK 0x00000000
#define ORBIS_FAIL 0xFFFFFFFF

// Libkernel library
#define ORBIS_KERNEL_ERROR_EPERM 0x80020001
#define ORBIS_KERNEL_ERROR_ENOENT 0x80020002
#define ORBIS_KERNEL_ERROR_ESRCH 0x80020003
#define ORBIS_KERNEL_ERROR_EINTR 0x80020004
#define ORBIS_KERNEL_ERROR_EIO 0x80020005
#define ORBIS_KERNEL_ERROR_ENXIO 0x80020006
#define ORBIS_KERNEL_ERROR_E2BIG 0x80020007
#define ORBIS_KERNEL_ERROR_ENOEXEC 0x80020008
#define ORBIS_KERNEL_ERROR_EBADF 0x80020009
#define ORBIS_KERNEL_ERROR_ECHILD 0x8002000A
#define ORBIS_KERNEL_ERROR_EDEADLK 0x8002000B
#define ORBIS_KERNEL_ERROR_ENOMEM 0x8002000C
#define ORBIS_KERNEL_ERROR_EACCES 0x8002000D
#define ORBIS_KERNEL_ERROR_EFAULT 0x8002000E
#define ORBIS_KERNEL_ERROR_ENOTBLK 0x8002000F
#define ORBIS_KERNEL_ERROR_EBUSY 0x80020010
#define ORBIS_KERNEL_ERROR_EEXIST 0x80020011
#define ORBIS_KERNEL_ERROR_EXDEV 0x80020012
#define ORBIS_KERNEL_ERROR_ENODEV 0x80020013
#define ORBIS_KERNEL_ERROR_ENOTDIR 0x80020014
#define ORBIS_KERNEL_ERROR_EISDIR 0x80020015
#define ORBIS_KERNEL_ERROR_EINVAL 0x80020016
#define ORBIS_KERNEL_ERROR_ENFILE 0x80020017
#define ORBIS_KERNEL_ERROR_EMFILE 0x80020018
#define ORBIS_KERNEL_ERROR_ENOTTY 0x80020019
#define ORBIS_KERNEL_ERROR_ETXTBSY 0x8002001A
#define ORBIS_KERNEL_ERROR_EFBIG 0x8002001B
#define ORBIS_KERNEL_ERROR_ENOSPC 0x8002001C
#define ORBIS_KERNEL_ERROR_ESPIPE 0x8002001D
#define ORBIS_KERNEL_ERROR_EROFS 0x8002001E
#define ORBIS_KERNEL_ERROR_EMLINK 0x8002001F
#define ORBIS_KERNEL_ERROR_EPIPE 0x80020020
#define ORBIS_KERNEL_ERROR_EDOM 0x80020021
#define ORBIS_KERNEL_ERROR_ERANGE 0x80020022
#define ORBIS_KERNEL_ERROR_EAGAIN 0x80020023
#define ORBIS_KERNEL_ERROR_EWOULDBLOCK 0x80020023
#define ORBIS_KERNEL_ERROR_EINPROGRESS 0x80020024
#define ORBIS_KERNEL_ERROR_EALREADY 0x80020025
#define ORBIS_KERNEL_ERROR_ENOTSOCK 0x80020026
#define ORBIS_KERNEL_ERROR_EDESTADDRREQ 0x80020027
#define ORBIS_KERNEL_ERROR_EMSGSIZE 0x80020028
#define ORBIS_KERNEL_ERROR_EPROTOTYPE 0x80020029
#define ORBIS_KERNEL_ERROR_ENOPROTOOPT 0x8002002A
#define ORBIS_KERNEL_ERROR_EPROTONOSUPPORT 0x8002002B
#define ORBIS_KERNEL_ERROR_ESOCKTNOSUPPORT 0x8002002C
#define ORBIS_KERNEL_ERROR_ENOTSUP 0x8002002D
#define ORBIS_KERNEL_ERROR_EOPNOTSUPP 0x8002002D
#define ORBIS_KERNEL_ERROR_EPFNOSUPPORT 0x8002002E
#define ORBIS_KERNEL_ERROR_EAFNOSUPPORT 0x8002002F
#define ORBIS_KERNEL_ERROR_EADDRINUSE 0x80020030
#define ORBIS_KERNEL_ERROR_EADDRNOTAVAIL 0x80020031
#define ORBIS_KERNEL_ERROR_ENETDOWN 0x80020032
#define ORBIS_KERNEL_ERROR_ENETUNREACH 0x80020033
#define ORBIS_KERNEL_ERROR_ENETRESET 0x80020034
#define ORBIS_KERNEL_ERROR_ECONNABORTED 0x80020035
#define ORBIS_KERNEL_ERROR_ECONNRESET 0x80020036
#define ORBIS_KERNEL_ERROR_ENOBUFS 0x80020037
#define ORBIS_KERNEL_ERROR_EISCONN 0x80020038
#define ORBIS_KERNEL_ERROR_ENOTCONN 0x80020039
#define ORBIS_KERNEL_ERROR_ESHUTDOWN 0x8002003A
#define ORBIS_KERNEL_ERROR_ETOOMANYREFS 0x8002003B
#define ORBIS_KERNEL_ERROR_ETIMEDOUT 0x8002003C
#define ORBIS_KERNEL_ERROR_ECONNREFUSED 0x8002003D
#define ORBIS_KERNEL_ERROR_ELOOP 0x8002003E
#define ORBIS_KERNEL_ERROR_ENAMETOOLONG 0x8002003F
#define ORBIS_KERNEL_ERROR_EHOSTDOWN 0x80020040
#define ORBIS_KERNEL_ERROR_EHOSTUNREACH 0x80020041
#define ORBIS_KERNEL_ERROR_ENOTEMPTY 0x80020042
#define ORBIS_KERNEL_ERROR_EPROCLIM 0x80020043
#define ORBIS_KERNEL_ERROR_EUSERS 0x80020044
#define ORBIS_KERNEL_ERROR_EDQUOT 0x80020045
#define ORBIS_KERNEL_ERROR_ESTALE 0x80020046
#define ORBIS_KERNEL_ERROR_EREMOTE 0x80020047
#define ORBIS_KERNEL_ERROR_EBADRPC 0x80020048
#define ORBIS_KERNEL_ERROR_ERPCMISMATCH 0x80020049
#define ORBIS_KERNEL_ERROR_EPROGUNAVAIL 0x8002004A
#define ORBIS_KERNEL_ERROR_EPROGMISMATCH 0x8002004B
#define ORBIS_KERNEL_ERROR_EPROCUNAVAIL 0x8002004C
#define ORBIS_KERNEL_ERROR_ENOLCK 0x8002004D
#define ORBIS_KERNEL_ERROR_ENOSYS 0x8002004E
#define ORBIS_KERNEL_ERROR_EFTYPE 0x8002004F
#define ORBIS_KERNEL_ERROR_EAUTH 0x80020050
#define ORBIS_KERNEL_ERROR_ENEEDAUTH 0x80020051
#define ORBIS_KERNEL_ERROR_EIDRM 0x80020052
#define ORBIS_KERNEL_ERROR_ENOMSG 0x80020053
#define ORBIS_KERNEL_ERROR_EOVERFLOW 0x80020054
#define ORBIS_KERNEL_ERROR_ECANCELED 0x80020055
#define ORBIS_KERNEL_ERROR_EILSEQ 0x80020056
#define ORBIS_KERNEL_ERROR_ENOATTR 0x80020057
#define ORBIS_KERNEL_ERROR_EDOOFUS 0x80020058
#define ORBIS_KERNEL_ERROR_EBADMSG 0x80020059
#define ORBIS_KERNEL_ERROR_EMULTIHOP 0x8002005A
#define ORBIS_KERNEL_ERROR_ENOLINK 0x8002005B
#define ORBIS_KERNEL_ERROR_EPROTO 0x8002005C
#define ORBIS_KERNEL_ERROR_ENOTCAPABLE 0x8002005D
#define ORBIS_KERNEL_ERROR_ECAPMODE 0x8002005E
#define ORBIS_KERNEL_ERROR_ENOBLK 0x8002005F
#define ORBIS_KERNEL_ERROR_EICV 0x80020060
#define ORBIS_KERNEL_ERROR_ENOPLAYGOENT 0x80020061

// AudioOut library
#define ORBIS_AUDIO_OUT_ERROR_NOT_OPENED 0x80260001
#define ORBIS_AUDIO_OUT_ERROR_BUSY 0x80260002
#define ORBIS_AUDIO_OUT_ERROR_INVALID_PORT 0x80260003
#define ORBIS_AUDIO_OUT_ERROR_INVALID_POINTER 0x80260004
#define ORBIS_AUDIO_OUT_ERROR_PORT_FULL 0x80260005
#define ORBIS_AUDIO_OUT_ERROR_INVALID_SIZE 0x80260006
#define ORBIS_AUDIO_OUT_ERROR_INVALID_FORMAT 0x80260007
#define ORBIS_AUDIO_OUT_ERROR_INVALID_SAMPLE_FREQ 0x80260008
#define ORBIS_AUDIO_OUT_ERROR_INVALID_VOLUME 0x80260009
#define ORBIS_AUDIO_OUT_ERROR_INVALID_PORT_TYPE 0x8026000A
#define ORBIS_AUDIO_OUT_ERROR_INVALID_CONF_TYPE 0x8026000C
#define ORBIS_AUDIO_OUT_ERROR_OUT_OF_MEMORY 0x8026000D
#define ORBIS_AUDIO_OUT_ERROR_ALREADY_INIT 0x8026000E
#define ORBIS_AUDIO_OUT_ERROR_NOT_INIT 0x8026000F
#define ORBIS_AUDIO_OUT_ERROR_MEMORY 0x80260010
#define ORBIS_AUDIO_OUT_ERROR_SYSTEM_RESOURCE 0x80260011
#define ORBIS_AUDIO_OUT_ERROR_TRANS_EVENT 0x80260012
#define ORBIS_AUDIO_OUT_ERROR_INVALID_FLAG 0x80260013
#define ORBIS_AUDIO_OUT_ERROR_INVALID_MIXLEVEL 0x80260014
#define ORBIS_AUDIO_OUT_ERROR_INVALID_ARG 0x80260015
#define ORBIS_AUDIO_OUT_ERROR_INVALID_PARAM 0x80260016
#define ORBIS_AUDIO_OUT_ERROR_MASTERING_FATAL 0x80260200
#define ORBIS_AUDIO_OUT_ERROR_MASTERING_INVALID_API_PARAM 0x80260201
#define ORBIS_AUDIO_OUT_ERROR_MASTERING_INVALID_CONFIG 0x80260202
#define ORBIS_AUDIO_OUT_ERROR_MASTERING_NOT_INITIALIZED 0x80260203
#define ORBIS_AUDIO_OUT_ERROR_MASTERING_INVALID_STATES_ID 0x80260204

// VideoOut library
#define ORBIS_VIDEO_OUT_ERROR_INVALID_VALUE 0x80290001
#define ORBIS_VIDEO_OUT_ERROR_INVALID_ADDRESS 0x80290002
#define ORBIS_VIDEO_OUT_ERROR_INVALID_PIXEL_FORMAT 0x80290003
#define ORBIS_VIDEO_OUT_ERROR_INVALID_PITCH 0x80290004
#define ORBIS_VIDEO_OUT_ERROR_INVALID_RESOLUTION 0x80290005
#define ORBIS_VIDEO_OUT_ERROR_INVALID_FLIP_MODE 0x80290006
#define ORBIS_VIDEO_OUT_ERROR_INVALID_TILING_MODE 0x80290007
#define ORBIS_VIDEO_OUT_ERROR_INVALID_ASPECT_RATIO 0x80290008
#define ORBIS_VIDEO_OUT_ERROR_RESOURCE_BUSY 0x80290009
#define ORBIS_VIDEO_OUT_ERROR_INVALID_INDEX 0x8029000A
#define ORBIS_VIDEO_OUT_ERROR_INVALID_HANDLE 0x8029000B
#define ORBIS_VIDEO_OUT_ERROR_INVALID_EVENT_QUEUE 0x8029000C
#define ORBIS_VIDEO_OUT_ERROR_INVALID_EVENT 0x8029000D
#define ORBIS_VIDEO_OUT_ERROR_NO_EMPTY_SLOT 0x8029000F
#define ORBIS_VIDEO_OUT_ERROR_SLOT_OCCUPIED 0x80290010
#define ORBIS_VIDEO_OUT_ERROR_FLIP_QUEUE_FULL 0x80290012
#define ORBIS_VIDEO_OUT_ERROR_INVALID_MEMORY 0x80290013
#define ORBIS_VIDEO_OUT_ERROR_MEMORY_NOT_PHYSICALLY_CONTIGUOUS 0x80290014
#define ORBIS_VIDEO_OUT_ERROR_MEMORY_INVALID_ALIGNMENT 0x80290015
#define ORBIS_VIDEO_OUT_ERROR_UNSUPPORTED_OUTPUT_MODE 0x80290016
#define ORBIS_VIDEO_OUT_ERROR_OVERFLOW 0x80290017
#define ORBIS_VIDEO_OUT_ERROR_NO_DEVICE 0x80290018
#define ORBIS_VIDEO_OUT_ERROR_UNAVAILABLE_OUTPUT_MODE 0x80290019
#define ORBIS_VIDEO_OUT_ERROR_INVALID_OPTION 0x8029001A
#define ORBIS_VIDEO_OUT_ERROR_UNKNOWN 0x802900FE
#define ORBIS_VIDEO_OUT_ERROR_FATAL 0x802900FF
#define ORBIS_VIDEO_OUT_ERROR_ENOMEM 0x8029100C

// Pad library
#define ORBIS_PAD_ERROR_INVALID_ARG 0x80920001
#define ORBIS_PAD_ERROR_INVALID_PORT 0x80920002
#define ORBIS_PAD_ERROR_INVALID_HANDLE 0x80920003
#define ORBIS_PAD_ERROR_ALREADY_OPENED 0x80920004
#define ORBIS_PAD_ERROR_NOT_INITIALIZED 0x80920005
#define ORBIS_PAD_ERROR_INVALID_LIGHTBAR_SETTING 0x80920006
#define ORBIS_PAD_ERROR_DEVICE_NOT_CONNECTED 0x80920007
#define ORBIS_PAD_ERROR_DEVICE_NO_HANDLE 0x80920008
#define ORBIS_PAD_ERROR_FATAL 0x809200FF
#define ORBIS_PAD_ERROR_NOT_PERMITTED 0x80920101
#define ORBIS_PAD_ERROR_INVALID_BUFFER_LENGTH 0x80920102
#define ORBIS_PAD_ERROR_INVALID_REPORT_LENGTH 0x80920103
#define ORBIS_PAD_ERROR_INVALID_REPORT_ID 0x80920104
#define ORBIS_PAD_ERROR_SEND_AGAIN 0x80920105

// UserService library
#define ORBIS_USER_SERVICE_ERROR_INTERNAL 0x80960001
#define ORBIS_USER_SERVICE_ERROR_NOT_INITIALIZED 0x80960002
#define ORBIS_USER_SERVICE_ERROR_ALREADY_INITIALIZED 0x80960003
#define ORBIS_USER_SERVICE_ERROR_NO_MEMORY 0x80960004
#define ORBIS_USER_SERVICE_ERROR_INVALID_ARGUMENT 0x80960005
#define ORBIS_USER_SERVICE_ERROR_OPERATION_NOT_SUPPORTED 0x80960006
#define ORBIS_USER_SERVICE_ERROR_NO_EVENT 0x80960007
#define ORBIS_USER_SERVICE_ERROR_NOT_LOGGED_IN 0x80960009
#define ORBIS_USER_SERVICE_ERROR_BUFFER_TOO_SHORT 0x8096000A

// SystemService library
#define ORBIS_SYSTEM_SERVICE_ERROR_PARAMETER 0x80A10003
